package com.muyu.marketing.domain.model;


import com.muyu.common.core.utils.bean.BeanUtils;
import com.muyu.marketing.domain.req.ActivityTeamInfoUpdReq;
import com.muyu.marketing.domain.req.ActivityTeamProductSkuInfoReq;
import com.muyu.marketing.domain.req.ActivityTeamProductSkuInfoUpdReq;
import com.muyu.marketing.domain.req.TeamProjectSkuInfoAddReq;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;


import java.util.List;

/**
 * 拼团活动修改模型
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ActivityTeamInfoUpdModel {
    /**
     * 活动id
     */
    private Long id;

    /**
     * 拼团名称
     */
    private String name;
    /**
     * 商品ID
     */
    private Long productId;
    /**
     * 商品活动图
     */
    private String productImage;
    /**
     * 活动简介
     */
    private String introduction;
    /**
     * 单位
     */

    private String unit;
    /**
     * 轮播图
     */
    private String imageList;

    /**
     * 活动排序
     */
    private Integer sort;

    /**
     * 活动详情
     */
    private String content;
    /**
     * 活动状态
     */
    private String status;

    private ActivityTeamProductSkuInfoModel activityTeamProductSkuInfoModel;
    /**
     *
     * @param activityTeamInfoUpdReq
     * @return
     */


    public static ActivityTeamInfoUpdModel activityTeamInfoUpdModel(ActivityTeamInfoUpdReq activityTeamInfoUpdReq){
        ActivityTeamProductSkuInfoReq activityTeamProductSkuInfoReq = activityTeamInfoUpdReq.getActivityTeamProductSkuInfoReq();
        List<ActivityTeamProductSkuInfoUpdReq> activityTeamProductSkuInfoUpdReq = activityTeamProductSkuInfoReq.getActivityTeamProductSkuInfoUpdReq();
        ActivityTeamProductSkuInfoModel teamProductSkuInfoModel = new ActivityTeamProductSkuInfoModel();
        List<ActivityTeamProductSkuInfoUpdModel> teamProductSkuInfoUpdModels = activityTeamProductSkuInfoUpdReq.stream().map(activityTeamProductSkuInfoUpdReq1 -> {
            ActivityTeamProductSkuInfoUpdModel activityTeamProductSkuInfoUpdModel = ActivityTeamProductSkuInfoUpdModel.builder()
                    .id(activityTeamProductSkuInfoUpdReq1.getId())
                    .teamStock(activityTeamProductSkuInfoUpdReq1.getTeamStock())
                    .teamPrice(activityTeamProductSkuInfoUpdReq1.getTeamPrice())
                    .build();
            return activityTeamProductSkuInfoUpdModel;
        }).toList();
        teamProductSkuInfoModel.setActivityTeamProductSkuUpdModel(teamProductSkuInfoUpdModels);
        List<TeamProjectSkuInfoAddReq> teamProjectSkuInfoAddReq = activityTeamProductSkuInfoReq.getTeamProjectSkuInfoAddReq();
        List<ActivityTeamProductSkuAddModel> skuAddModels = teamProjectSkuInfoAddReq.stream().map(teamProjectSkuInfoAddReq1 -> {
            ActivityTeamProductSkuAddModel productSkuAddModel = ActivityTeamProductSkuAddModel.builder()
                    .teamId(activityTeamInfoUpdReq.getId())
                    .productId(activityTeamInfoUpdReq.getProductId())
                    .productSku(teamProjectSkuInfoAddReq1.getProductSku())
                    .teamPrice(teamProjectSkuInfoAddReq1.getTeamPrice())
                    .teamStock(teamProjectSkuInfoAddReq1.getTeamStock())
                    .build();
            return productSkuAddModel;
        }).toList();
        teamProductSkuInfoModel.setActivityTeamProductSkuAddModelList(skuAddModels);
        teamProductSkuInfoModel.setSkuIdList(activityTeamInfoUpdReq.getActivityTeamProductSkuInfoReq().getSkuIdList());

        return ActivityTeamInfoUpdModel.builder()
                .id(activityTeamInfoUpdReq.getId())
                .name(activityTeamInfoUpdReq.getName())
                .productId(activityTeamInfoUpdReq.getProductId())
                .productImage(activityTeamInfoUpdReq.getProductImage())
                .introduction(activityTeamInfoUpdReq.getIntroduction())
                .unit(activityTeamInfoUpdReq.getUnit())
                .imageList(activityTeamInfoUpdReq.getImageList())
                .sort(activityTeamInfoUpdReq.getSort())
                .content(activityTeamInfoUpdReq.getContent())
                .status(activityTeamInfoUpdReq.getStatus())
                .activityTeamProductSkuInfoModel(teamProductSkuInfoModel)
              .build();
    }

}
